---
title: do...while
slug: Web/JavaScript/Reference/Statements/do...while
tags:
  - JavaScript
  - Language feature
  - Statement
---
<div>{{jsSidebar("Statements")}}</div>

<p>The <strong><code>do...while</code> statement</strong> creates a loop that executes a specified statement until the test condition evaluates to false. The condition is evaluated after executing the statement, resulting in the specified statement executing at least once.</p>

<div>{{EmbedInteractiveExample("pages/js/statement-dowhile.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">do
   <em>statement</em>
while (<em>condition</em>);
</pre>

<dl>
 <dt><code><em>statement</em></code></dt>
 <dd>A statement that is executed at least once and is re-executed each time the condition evaluates to true. To execute multiple statements within the loop, use a {{jsxref("Statements/block", "block", "", 1)}} statement (<code>{ ... }</code>) to group those statements.</dd>
</dl>

<dl>
 <dt><code><em>condition</em></code></dt>
 <dd>An expression evaluated after each pass through the loop. If <code>condition</code> evaluates to true, the <code>statement</code> is re-executed. When <code>condition</code> evaluates to false, control passes to the statement following the <code>do...while</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_do...while">Using <code>do...while</code></h3>

<p>In the following example, the <code>do...while</code> loop iterates at least once and reiterates until <code>i</code> is no longer less than 5.</p>

<pre class="brush: js">var result = '';
var i = 0;
do {
   i += 1;
   result += i + ' ';
}
while (i &gt; 0 &amp;&amp; i &lt; 5);
// Despite i == 0 this will still loop as it starts off without the test

console.log(result);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-do-while-statement', 'do-while statement')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.do_while")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/while", "while")}}</li>
 <li>{{jsxref("Statements/for", "for")}}</li>
</ul>
